﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr171_1
{
    // Объявление делегата: 
    delegate int Method(int n);

    // Класс с индексатором: 
    class MyClass {
        // Закрытое целочисленное поле: 
        private int num;
        // Конструктор с целочисленным аргументом: 
        public MyClass(int n) { 
            num = n;
        }
        // Первый закрытый метод: 
        private int first(int n) { 
            return n + num;
        }
        // Второй закрытый метод: 
        private int second(int n) { 
            return n - num;
        }
        // Третий закрытый метод: 
        private int third(int n) { 
            return n * num;
        }
        // Индексатор с целочисленным индексом.
        // Результат - ссылка на экземпляр делегата: 
        public Method this[int k] {
            // Аксессор для считывания значения: 
            get {
                switch(k) { 
                    case 0:
                        return first; 
                    case 1:
                        return second; 
                    default:
                        return third;
                }
            }
        }
    }

    // Класс с главным методом:
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Переменная: 
            int x = 12;
            // Создание объекта:
            MyClass obj = new MyClass(4);
            // Индексирование объекта: 
            for (int k = 0; k <= 2; k++)
            {
                Console.WriteLine("obj[{0}]({1}) = {2}", k, x, obj[k](x));
            }
            // Задержка:
            Console.ReadLine();
        }
    }
}
